import 'package:unit_rc/UnitRCLog.dart';

typedef UnitRCGetApplicationCallback = dynamic Function();

class UnitRCApplication {
  UnitRCApplication._();

  static Set<dynamic>? _validApplication;
  static UnitRCGetApplicationCallback? _getApplicationCallback;

  static void registerGetApplicationCallback(
      UnitRCGetApplicationCallback callback) {
    _getApplicationCallback = callback;
  }

  static bool isApplicationValid(dynamic application) {
    return _validApplication?.contains(application) ?? false;
  }

  static dynamic getCurrApplication() {
    return _getApplicationCallback?.call();
  }

  static void registerCurrApplication() {
    final application = _getApplicationCallback?.call();
    if (application == null) {
      UnitRCLog.error("application is null");
      return;
    }
    if (_validApplication == null) {
      _validApplication = {};
    }
    UnitRCLog.info("register application: ${application}");
    _validApplication?.add(application);
  }

  static void unregisterCurrApplication() {
    final application = _getApplicationCallback?.call();
    if (application == null) {
      UnitRCLog.error("application is null");
      return;
    }
    UnitRCLog.info("unregister application: ${application}");
    _validApplication?.remove(application);
  }
}
